<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        @keyframes hide {
            0%{
                opacity:1;
                line-height: 100%;
                padding: 20px;
                margin: 10px;
            }
            75%{
                opacity:0;
                line-height: 100%;
                padding: 20px;
                margin: 10px;
            }
            100%{
                opacity:0;
                line-height: 0%;
                padding: 0px;
                margin: 0px;
            }
        }

        .post{
            background-color:  cornflowerblue;
            padding: 20px;
            margin: 10px;
            animation-name: hide;
            animation-duration: 1s;
            animation-fill-mode:forwards;
            animation-play-state: paused;
        }
        body{
            padding-bottom: 50px;
        }
        .hide{
           float: right;
        }
    </style>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/handlebars.js/4.0.11/handlebars.min.js"></script>
    <script id="post" type="text/x-handlebars-template">
        <div class="post">
            {% raw -%}
                {{ contents }}
            {%- endraw %}
            <button class="hide">Hide</button>
        </div>
    </script>
    <script>
        let counter = 1;
        const quantity = 20;
        document.addEventListener('DOMContentLoaded',load);

        window.onscroll = () => {
            if (window.innerHeight + window.scrollY >= document.body.offsetHeight){
                load();
            }
        };

        document.addEventListener('click', event => {
        const element = event.target;
        if (element.className === 'hide') {
            element.parentElement.style.animationPlayState = 'running';
            element.parentElement.addEventListener('animationend', () => {
            element.parentElement.remove();
                });
            }
        });

        function load() {
            const start = counter;
            const end = start+quantity-1;
            counter = end+1;


            const request = new XMLHttpRequest();
            request.open('POST', '/posts');
            request.onload = () => {
                const data =JSON.parse(request.responseText);
                data.forEach(add_post);
            };


            const data = new FormData();
            data.append('start',start);
            data.append('end',end);

            request.send(data);
            
        };

        const post_template = Handlebars.compile(document.querySelector("#post").innerHTML);
        function add_post(contents){
            const post = post_template({'contents':contents});

            document.querySelector("#body").innerHTML += post;
        }

        // without hadlebars creating contents !!!!

        // function add_post(content){
        //     const post = document.createElement('div');
        //     post.className = 'post';
        //     post.innerHTML = content;

        //     const hide = document.createElement("button");
        //     hide.className = 'hide';
        //     hide.innerHTML = 'Hide';
        //     post.append(hide);
        //     hide.onclick = function() {
        //         this.parentElement.remove();
        //     };
        //     document.querySelector('#body').append(post);
        // };

    </script>
</head>
<body>
    <div id="body"></div>
</body>
</html>